<template>
  <v-dialog v-model="drawer" width="50%" persistent>
    <v-card>
      <v-card-title class="d-flex">
        <v-sheet class="me-auto"
          >Invite people to
          <code>{{ ISAStore.currentInvestigation.name }}</code></v-sheet
        >
        <v-sheet
          ><v-btn
            icon="$close"
            density="comfortable"
            variant="plain"
            @click="close"
          ></v-btn
        ></v-sheet>
      </v-card-title>
      <v-card-text>
        <h1></h1>

        <v-select
          v-model="role"
          :items="dialog_roles"
          :item-props="itemProps"
          prepend-icon="mdi-card-account-details-outline"
          label="Role *"
        ></v-select>

        <v-autocomplete
          v-model="inputUsername"
          v-model:search.sync="search"
          :items="entries"
          :loading="isLoading"
          menu-icon=""
          hide-no-data
          hide-selected
          :item-title="getItemTitle"
          :item-value="getItemValue"
          label="Members"
          multiple
          chips
          closable-chips
          placeholder="Start typing to Search"
          prepend-icon="mdi-account-multiple-plus-outline"
		  @change="onSelectChange"
        >
          <template v-slot:chip="{ props, item }">
            <v-chip
              v-bind="props"
              :text="item?.raw?.first_name + `  ` + item?.raw?.last_name"
            ></v-chip>
          </template>

          <template v-slot:item="{ props, item }">
            <v-list-item
              v-bind="props"
              :title="item?.raw?.first_name + `  ` + item?.raw?.last_name"
              :subtitle="`@` + item?.raw?.username"
            ></v-list-item>
          </template>
        </v-autocomplete>

        <div class="d-flex flex-row-reverse">
          <v-btn @click="addMember">Add</v-btn>
        </div>
      </v-card-text>
    </v-card>
  </v-dialog>

  <Snackbar
    :text="snackbarMessage"
    :type="snackbarMessageType"
    @messageDisplayed="
      snackbarMessage = null;
      snackbarMessageType = null;
    "
  />
</template>
  
<script>
import { useISAStore } from "@/stores/useISAStore";
import _, { indexOf } from "lodash";

export default {
	props: {
		investigationAddMembersDialog: {
			required: true,
		},
	},
	setup(props) {
		const ISAStore = useISAStore();
		return { ISAStore };
	},
	data() {
		return {
			drawer: null,
			countMembers: 0,
			inputEmail: "",
			inputUsername: [],
			emails: [],
			emailMessage: "",
			dialog_roles: [],
			userIdentifier: null,
			search: null,
			role: "",
			entries: [],
			isLoading: false,
			isUpdating: false,
			snackbarMessage: null,
			snackbarMessageType: null,
			snackbar: false,
			timeout: 3000,
			fields: null,
			newEntries: [],
		};
	},

	async mounted() {
		useAPIFetch("/api/members/description/roles").then((response) => {
			this.dialog_roles = response.data;
		});
	},
	emits: ["investigationAddMembersDialog", "newMember"],
	watch: {
		inputUsername() {
			this.search = "";
		},
		investigationAddMembersDialog(newValue) {
			this.drawer = newValue;
		},
		search: _.debounce(function (val) {

			if (!val) {
				return;
			}
			if (val === "") {
				return;
			}

			if (val.length < 3) {
				return;
			}

			this.isLoading = true;
			// this.newEntries= this.newEntries.push(this.entries);

			// Lazily load input items
			useAPIFetch("/api/users/?search=" + val)
				.then((res) => {
					const data = res.data.value;
					const error = res.error.value;
					if (error) {
						// dealing error
						console.log(error);
					} else {
						// this.entries = data.results;
						this.newEntries = this.newEntries.concat(data.results);
						this.entries = this.newEntries;
					}
				})
				.finally(() => (this.isLoading = false));
		}, 500),
	},
	methods: {
		// The `close()` method is responsible for closing the dialog by setting the
		// `drawer` data property to `false`. It also emits an event called
		// "investigationAddMembersDialog" with a value of `false` to notify the parent
		// component that the dialog has been closed.

		// Handle changes when the user selects an option
		onSelectChange() {
			const selectedId = this.inputUsername.id;
			this.inputUsername.push(selectedId);
		},

		getSearchResultById(id) {
			return this.entries.find((results) => results.id === id);
		},
		
		close() {
			this.drawer = false;
			this.$emit("investigationAddMembersDialog", false);
		},
		// The `addNewEmails()` method is responsible for adding new email addresses to
		// the `emails` array after a regex check.
		addNewEmails() {
			const pattern =
        /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;

			if (this.inputEmail.length > 0) {
				if (pattern.test(this.inputEmail)) {
					this.emailMessage = "";
					this.emails.push(this.inputEmail);
					this.inputEmail = "";
				} else {
					this.emailMessage = "Invalid e-mail.";
				}
			}
		},
		getItemTitle(item) {
			return `${item.first_name} ${item.last_name}\n(${item.username})`;
		},
		getItemValue(item) {
			return `${item.username}`;
		},
		// The `remove(email)` method is responsible for removing an email address from
		// the `emails` array.
		remove(email) {
			let idx = this.emails.indexOf(email);
			this.emails.splice(idx, 1);
			this.emails = [...this.emails];
		},
		// The `addMember()` method is an asynchronous function that is responsible for
		// adding a new member to an investigation.
		async addMember() {
			let userAdded = 0;
			for (let username of this.inputUsername) {
				await useAPIFetch(
					"/api/investigations/" +
            		this.ISAStore.currentInvestigation.id +
            		"/members/",
					{
						method: "POST",
						body: {
							username: username,
							role: this.role.role,
						},
					}
				).then((res) => {
					const error = res.error.value;
					userAdded ++;
					if (error) {
						throw error;
					} else if (userAdded === this.inputUsername.length) {
						console.log("finish");
						// this.snackbarMessage = "New members added !";
						this.snackbarMessageType = "success";
						this.snackbar = true;
						this.$emit("newMember", true);
						this.$emit("investigationAddMembersDialog", false);
					}
				});
			}
			this.role = "";
			this.inputUsername = [];
			this.entries = [];
			this.newEntries = [];
			this.userIdentifier = null;
			this.drawer = false;
		},
		// The `itemProps(item)` method is used to define the properties of each item
		// in the `v-select` component. It takes an `item` as a parameter and returns
		// an object with the `title` and `subtitle` properties. These properties are
		// used to display the title and subtitle of each item in the dropdown menu of
		// the `v-select` component. In this case, the `title` property is set to
		// `item.role` and the `subtitle` property is set to `item.description`.
		itemProps(item) {
			return {
				title: item.role,
				subtitle: item.description,
			};
		},
	},
};
</script>
